<?php

namespace Sharkk\Web;

use Sharkk\Router\Router;
use Sharkk\Router\SegmentRouter;

class App
{
	private Router $router;
	private Request $request;

	public function __construct()
	{
		$this->request = new Request;
		$this->router = new SegmentRouter;
	}

	public function get(string $route, callable $handler): void
	{
		$this->router->add('GET', $route, $handler);
	}

	public function post(string $route, callable $handler): void
	{
		$this->router->add('POST', $route, $handler);
	}

	public function run(string $method, string $uri): void
	{
		$l = $this->router->lookup($method, $uri);

		if ($l['code'] === 404) {
			http_response_code(404);
			echo "Not Found\n";
			return;
		}

		if ($l['code'] === 405) {
			http_response_code(405);
			echo "Method Not Allowed\n";
			return;
		}

		$l['handler'](...$l['params'] ?? []);
	}
}
